#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;

vector<pair<ld,int>> broom;

ld sq_dist(pair<ld,ld> x, pair<ld,ld> y)
{
	return (x.first-y.first)*(x.first-y.first) + (x.second-y.second)*(x.second-y.second);
}

ld scalar(pair<ld,ld> x, pair<ld,ld> y)
{
	return x.first*y.first + x.second*y.second;
}

void add_boat(pair<ld,ld> boat, pair<ld,ld> v, ld SQ, ld b_len)
{
	ld proj_len = scalar(boat,v);
	pair<ld,ld> projection = make_pair(v.first * proj_len, v.second * proj_len);
	ld H = sq_dist(boat, projection);
	ld dif = SQ - H;
	if(dif < 0.0) return;
	ld rad = sqrt(dif);

	ld bg = proj_len - rad;
	ld ed = proj_len + rad;

	broom.push_back(make_pair(bg,1));
	broom.push_back(make_pair(ed,-1));
}

int main()
{
	ll n,r,A,B;
	scanf("%lld%lld%lld%lld",&n,&r,&A,&B);
	ld R = ld(r) + 2e-4;

	pair<ld,ld> vec_ab = make_pair(ld(A),ld(B));
	ld norm_ab = sqrt(scalar(vec_ab, vec_ab));
	pair<ld,ld> normal_ab = make_pair(ld(A)/norm_ab,ld(B)/norm_ab);
	ld b_len = sqrt(scalar(vec_ab,vec_ab));

	for(int i=1;i<=n;i++)
	{
		ll x,y;
		scanf("%lld%lld",&x,&y);
		add_boat(make_pair(ld(x), ld(y)), normal_ab, R*R, b_len);
	}

	sort(broom.begin(), broom.end(), [](pair<ld,int> a, pair<ld,int> b){return a.first<b.first; });

	int mx = 0;
	int il = 0;
	for(auto z : broom)
	{
		//printf("(%lf %d)\n",z.first,z.second);

		il += z.second;
		mx = max(mx, il);
	}

	printf("%d\n",mx);
}
